#include "date2ut.h"

/*1̕b(=24*60*60)*/
#define SECONDS_PER_DAY 86400

/*1NyearN܂Łi[܂ށj̓߂*/
static long long getDays(int year) {
	long long result;
	if(year<0)return -getDays(-year)-366+365;
	else if(year==0)return 0;
	result=year*365;/*1N͊{365*/
	result+=year/4;/*4Ŋ؂ꂽ[N*/
	result-=year/100;/*100Ŋ؂ꂽ[Nł͂Ȃ*/
	result+=year/400;/*400Ŋ؂ꂽ[N*/
	return result;
}

/*1970N11@00:00:00̌oߕbԂ*/
long long date2ut(int year,int month,int date,
		int hour,int minute,int second) {
	const int monthDays[13]={
			0,31,59,90,120,151,181,212,243,273,304,334,365
	};/*̌܂ł̘̓aiݐϘaj*/
	long long result;
	/*ANZXᔽɂȂs͂Ȃ0Ԃ*/
	if(month<1 || month>12)return 0;
	/* yearN11 00:00:00܂ł̓߂*/
	result=getDays(year-1)-getDays(1969);
	/*bɕϊ*/
	result*=SECONDS_PER_DAY;
	/*̓bɕϊđ*/
	result+=monthDays[month-1]*SECONDS_PER_DAY;
	/*[N3ȍ~Ȃ1*/
	if(year%400==0 || (year%4==0 && year%100!=0)) {
		if(month>=3)result+=SECONDS_PER_DAY;
	}
	/*̌̓bɕϊđ*/
	result+=(date-1)*SECONDS_PER_DAY;
	/*Ԃ𑫂*/
	result+=hour*60*60;
	/*𑫂*/
	result+=minute*60;
	/*b𑫂*/
	result+=second;
	/*ʂԂ*/
	return result;
}
